﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Http;
using Sample142103;
using Syncfusion.EJ.Export;
using Syncfusion.JavaScript.Models;
using Syncfusion.XlsIO;
using System.Web.Script.Serialization;
using System.Collections;
using System.Reflection;
using MVCSampleBrowser.Models;
using Syncfusion.JavaScript;
using System.Drawing;
namespace Sample142103.Controllers
{
    public class GridController : Controller
    {
        //
        // GET: /Grid/

        public ActionResult GridFeatures()
        {
            var ds = new NorthwindDataContext().OrdersViews.ToList();           
            ViewBag.datasource = ds;
            return View();
        }

        public void ExportToExcel(string GridModel)
        {
            var exp = new ExcelExport();
            var ds = new NorthwindDataContext().OrdersViews.ToList();              
            GridProperties obj = ConvertGridObject(GridModel);
            AutoFormat auto = new AutoFormat();
            GridExtensions ext = new GridExtensions();
            ext.SetTheme(auto, "default-theme");
            auto.FontFamily = "Arial Narrow";
            auto.ContentFontSize = 8;
            auto.HeaderFontSize = 12;
            auto.GHeaderBgColor = Color.Crimson;
            obj.AutoFormat = auto;
            obj.ServerExcelRowInfo = querycell;
            var destination = Server.MapPath("~/App_Data");
            exp.Export(obj, ds, "Export.xlsx", ExcelVersion.Excel2010, false, false, "flat-saffron", true, destination);
        }
        public void querycell(object sender)
        {
            var data = (IRange)sender;
            
            if (data.Column == 4 && (data.Row >= 2 && data.Row < 6) )
            {
                data.HorizontalAlignment = ExcelHAlign.HAlignLeft;
                data.NumberFormat = "#,##0.00";
            }
        }
        private GridProperties ConvertGridObject(string gridProperty)
        {
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            IEnumerable div = (IEnumerable)serializer.Deserialize(gridProperty, typeof(IEnumerable));
            GridProperties gridProp = new GridProperties();
            foreach (KeyValuePair<string, object> ds in div)
            {
                var property = gridProp.GetType().GetProperty(ds.Key, BindingFlags.Instance | BindingFlags.Public | BindingFlags.IgnoreCase);
                if (property != null)
                {
                    Type type = property.PropertyType;
                    string serialize = serializer.Serialize(ds.Value);
                    object value = serializer.Deserialize(serialize, type);
                    property.SetValue(gridProp, value, null);
                }
            }
            return gridProp;
        }

        public class FooTest
        {
            public int ID { get; set; }
            public string Name { get; set; }
        }
    }
}
